/* This program is free software; you can redistribute it and/or                */
/* modify it under the terms of the GNU General Public License                  */
/* as published by the Free Software Foundation; either version 2               */
/* of the License, or (at your option) any later version.                       */
/*                                                                              */
/* This program is distributed in the hope that it will be useful,              */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/* GNU General Public License for more details.                                 */
/*                                                                              */
/* You should have received a copy of the GNU General Public License            */
/* along with this program; if not, write to the Free Software                  */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.  */
/*                                                                              */
/* ---------------------------------------------------------------------------- */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

typedef struct k_cext
{
  t_object x_ob;
  t_float *values;

  int num_ins;
  int num_outs;

  t_inlet **inlets;
  t_outlet **outlets;

  void (*k_cext_process)(struct k_cext *x);
  void *handle;

  char filename[20];

  void *userdata; // This attribute /can/ be used by a patch, but using "static" is much cleaner, so please don't.
} t_k_cext;


extern int k_sys_getprocessfunction(t_k_cext *x,char *funcname,char *name);
extern void k_sys_freehandle(t_k_cext *x);
extern void k_sys_mktempfilename(char *to);
extern void k_sys_writeincludes(FILE *file);
extern void k_sys_makecompilestring(char *to,char *name);
extern void k_sys_deletefile(char *name);
void k_sys_init(void);

#define V(a) (x->values[a])
#define I(a) ((int)(x->values[a]))


/* NOTE! Using O(0-6,b) instead of O0-6(b) might not be compatible
   with future versions! O(>6) will hopefully be. 
*/
#define O(a,b) outlet_float(x->outlets[a],b)

#define O0(b) O(0,b)
#define O1(b) O(1,b)
#define O2(b) O(2,b)
#define O3(b) O(3,b)
#define O4(b) O(4,b)
#define O5(b) O(5,b)
#define O6(b) O(6,b)



#define BEGIN {
#define END }
#define ELSE }else{

#define SC ;

#define NL "\n"

#define SP " "


