/* k_cext_macosx.c. MacosX part of k_cext. Made by Kjetil Matheussen. Never tested. */
//
/* This program is free software; you can redistribute it and/or                */
/* modify it under the terms of the GNU General Public License                  */
/* as published by the Free Software Foundation; either version 2               */
/* of the License, or (at your option) any later version.                       */
/*                                                                              */
/* This program is distributed in the hope that it will be useful,              */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/* GNU General Public License for more details.                                 */
/*                                                                              */
/* You should have received a copy of the GNU General Public License            */
/* along with this program; if not, write to the Free Software                  */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.  */
/*                                                                              */
/* ---------------------------------------------------------------------------- */

#include "m_pd.h"
#include "k_cext.h"

#include <unistd.h>

#include <mach-o/dyld.h> 

int k_sys_getprocessfunction(t_k_cext *x,char *name){
  NSObjectFileImage image; 
  void *ret;
  NSSymbol s; 

  x->k_cext_process=NULL;
  x->handle=NULL;

  if ( NSCreateObjectFileImageFromFile( name, &image) != NSObjectFileImageSuccess ){
    post("Error. \n");
    return 0;
  }
  ret=NSLinkModule( image, name, NSLINKMODULE_OPTION_BINDNOW); 
  s = NSLookupSymbolInModule(ret, "k_cext_process"); 
  
  if (s)
    x->k_cext_process = (t_xxx)NSAddressOfSymbol( s);

  return 1;
}

void k_sys_freehandle(t_k_cext *x){
  post("FIX ME.\n");
}

void k_sys_mktempfilename(char *to){
  char temp[500];

  sprintf(to,"pd-XXXXXX");
  mktemp(to);

  sprintf(temp,"%s.c.o",x->filename);
  unlink(temp);
}

void k_sys_writeincludes(FILE *file){
  fprintf(file,"#include \"" INCLUDEPATH "/" LINUXINCLUDE "/m_pd.h\"\n");
  fprintf(file,"#include \"" INCLUDEPATH  "/k_cext.h\"\n");
}


void k_sys_makecompilestring(char *to,char *name){
  sprintf(to,"cl %s " INCLUDEPATH "\\bin\\pd.lib /LD /Gd /GD /Ox /DNT /link /export:k_cext_process",name);
}

void k_sys_deletefile(char *name){
  unlink(name);
}

static void k_sys_cleanup(void){
  system("rm -fr /tmp/pd-k_cext-*");
}

static void finish(int sig){
  k_sys_cleanup();
  exit(0);
}


void k_sys_init(void){
  atexit(k_sys_cleanup);
  signal(SIGINT,finish);
}
